import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule, NoopAnimationsModule } from '@angular/platform-browser/animations';
import { Component, Input, ViewChild, ElementRef, Directive, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/grid/grid.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GridComponent {
    /**
     * @param {?} rows
     * @return {?}
     */
    set rowSizes(rows) {
        this.grid.nativeElement.style['grid-template-rows'] = rows;
    }
    /**
     * @param {?} cols
     * @return {?}
     */
    set columnSizes(cols) {
        this.grid.nativeElement.style['grid-template-columns'] = cols;
    }
}
GridComponent.decorators = [
    { type: Component, args: [{
                selector: 'fdn-grid',
                template: "<div class=\"grid\" #grid>\n  <ng-content></ng-content>\n</div>\n",
                styles: [":host{display:block}.grid{display:grid;display:-ms-grid}"]
            }] }
];
GridComponent.propDecorators = {
    grid: [{ type: ViewChild, args: ['grid',] }],
    rowSizes: [{ type: Input }],
    columnSizes: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/grid-item/grid-item.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GridItemDirective {
    /**
     * @param {?} el
     */
    constructor(el) {
        this.el = el;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set row(val) {
        this._row = val;
        this.el.nativeElement.style.gridRow = val;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set col(val) {
        this._col = val;
        this.el.nativeElement.style.gridColumn = val;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set rowSpan(val) {
        this._rowSpan = val;
        this.el.nativeElement.style.gridRowEnd = this._row + val;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set colSpan(val) {
        this._colSpan = val;
        this.el.nativeElement.style.gridColumnEnd = this._col + val;
    }
    /**
     * @param {?} debug
     * @return {?}
     */
    set debug(debug) {
        if (debug) {
            this.el.nativeElement.style.border = '1px solid black';
            this.el.nativeElement.style.backgroundColor = this.randomRGB();
        }
    }
    ;
    /**
     * @return {?}
     */
    random() {
        return Math.floor(Math.random() * 128) + 127;
    }
    /**
     * @return {?}
     */
    randomRGB() {
        return `rgba(${this.random()}, ${this.random()}, ${this.random()}, 1)`;
    }
}
GridItemDirective.decorators = [
    { type: Directive, args: [{
                selector: '[fdn-grid-item]'
            },] }
];
/** @nocollapse */
GridItemDirective.ctorParameters = () => [
    { type: ElementRef }
];
GridItemDirective.propDecorators = {
    row: [{ type: Input }],
    col: [{ type: Input }],
    rowSpan: [{ type: Input }],
    colSpan: [{ type: Input }],
    debug: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/img/img.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ImgComponent {
    constructor() {
        this.style = {
            'transform': 'skew(0)',
            'height.px': '100',
            'width.px': '100',
        };
        this.imgStyle = {
            'transform': 'skew(0)',
        };
    }
    /**
     * @param {?} num
     * @return {?}
     */
    set angle(num) {
        this.style['transform'] = `skew(${num}deg)`;
        this.imgStyle['transform'] = `skew(-${num}deg)`;
    }
    /**
     * @param {?} num
     * @return {?}
     */
    set height(num) {
        this.style['height.px'] = `${num}`;
    }
    ;
    /**
     * @param {?} num
     * @return {?}
     */
    set width(num) {
        this.style['width.px'] = `${num}`;
        this.imgStyle['width.px'] = `${num}`;
    }
    ;
    /**
     * @param {?} num
     * @return {?}
     */
    set imgWidth(num) {
        this.imgStyle['width.px'] = `${num}`;
    }
    ;
    /**
     * @param {?} num
     * @return {?}
     */
    set left(num) {
        this.imgStyle['left.px'] = `-${num}`;
    }
    /**
     * @param {?} num
     * @return {?}
     */
    set top(num) {
        this.imgStyle['top.px'] = `-${num}`;
    }
    /**
     * @return {?}
     */
    getHeight() {
        this.imgWidth = this.img.nativeElement.offsetHeight;
    }
}
ImgComponent.decorators = [
    { type: Component, args: [{
                selector: 'fdn-img',
                template: "<div [ngStyle]=\"style\">\n  <img #imgElem [ngStyle]=\"imgStyle\" [attr.src]=\"src\" [attr.alt]=\"alt\" (load)=\"getHeight()\">\n</div>",
                styles: ["div{overflow:hidden;position:relative}div img{position:absolute}"]
            }] }
];
/** @nocollapse */
ImgComponent.ctorParameters = () => [];
ImgComponent.propDecorators = {
    alt: [{ type: Input }],
    src: [{ type: Input }],
    img: [{ type: ViewChild, args: ['imgElem',] }],
    angle: [{ type: Input }],
    height: [{ type: Input }],
    width: [{ type: Input }],
    imgWidth: [{ type: Input }],
    left: [{ type: Input }],
    top: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/header/header.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class HeaderComponent {
    // add facade here to do signin and signout?
    constructor() {
        this.navOpen = false;
        this.showSkip = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    signIn() { }
    /**
     * @return {?}
     */
    signUp() { }
    /**
     * @param {?} user
     * @return {?}
     */
    signOut(user) { }
    /**
     * @return {?}
     */
    skipToMain() { }
}
HeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'fdn-header',
                template: "<div class=\"button-container\">\n  <button\n    class=\"fdn-skip\"\n    [class.accessible]=\"!showSkip\"\n    (focus)=\"showSkip = true\"\n    (blur)=\"showSkip = false\"\n    (click)=\"skipToMain()\"\n    >\n    Skip to Main Content\n  </button>\n  <button [@nav]=\"navOpen\" class=\"fdn-nav\" (click)=\"navOpen = !navOpen\" [attr.aria-expanded]=\"navOpen\">\n    <svg width=\"24px\" height=\"24px\">\n      <rect\n        x=\"0\"\n        y=\"0\"\n        [attr.width]=\"24\"\n        [attr.height]=\"24\"\n        [attr.fill]=\"'#000'\">\n      </rect>\n      <rect \n        x=\"3\"\n        y=\"3\"\n        [attr.width]=\"navOpen ? 7 : 2\"\n        [attr.height]=\"18\"\n        [attr.fill]=\"'#FC0'\">\n      </rect>\n    </svg>\n    <span class=\"accessible\">navigation</span>\n  </button>\n  <div class=\"fdn-login\">\n    <ng-container *ngIf=\"user$ | async as user else noUser\">\n      <div class=\"fdn-session\" *ngIf=\"user\">\n        <button (click)=\"signOut(user)\">\n          {{ user.displayName ? user.displayName : user.email }}\n        </button>\n      </div>\n    </ng-container>\n    <ng-template #noUser>\n      <div class=\"fdn-sessionless\">\n        <button (click)=\"signIn()\">Login</button>\n        <button (click)=\"signUp()\">Signup</button>\n      </div>\n    </ng-template>\n  </div>\n</div>",
                styles: ["nav{display:-webkit-box;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;flex-direction:column;margin-top:4rem}nav a{margin:8px}.button-container{position:fixed;z-index:10;background:#333;width:100%;display:-webkit-box;display:flex;-webkit-box-pack:justify;justify-content:space-between}@media (max-width:512px){.button-container{position:relative}}.button-container button{background:0 0;border:none;height:24px;margin:8px}.button-container .fdn-nav{background:#fc0}.button-container .fdn-skip{position:fixed;width:100%;background:#fc0;z-index:20}.button-container .fdn-login{position:relative;background:#fc0}header{display:-webkit-box;display:flex}@media (min-width:768px){header{margin-top:2rem}}main{min-height:100vh}"]
            }] }
];
/** @nocollapse */
HeaderComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/foundation.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const EXPORTED = [GridComponent, GridItemDirective, ImgComponent, HeaderComponent];
class FoundationModule {
}
FoundationModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, BrowserAnimationsModule, NoopAnimationsModule],
                declarations: EXPORTED,
                exports: EXPORTED,
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: artesgo-foundation.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FoundationModule, GridItemDirective as ɵb, GridComponent as ɵa, HeaderComponent as ɵd, ImgComponent as ɵc };

//# sourceMappingURL=artesgo-foundation.js.map